



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【Android测试】【第二节】性能——CPU时间片</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【Android测试】【第二节】性能——CPU时间片</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 13:01:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>◆<strong>版权声明：本文出自<strong>胖喵~</strong>的博客，转载必须注明出处。</strong></p>
<p>转载请注明出处：<em><a href="http://www.cnblogs.com/by-dream/p/5143192.html" rel="external nofollow noreferrer">http://www.cnblogs.com/by-dream/p/5143192.html</a></em></p>
<p><strong>前言</strong></p>
<hr />
<p>　　第一节讲CPU的时候留下了一个疑问，就是由于Android手机系统本身的缺陷造成采集CPU百分比数据会有很大的误差，那么如何分析CPU这个指标呢？</p>
<p>　　这节我们就来讲讲如何用CPU时间片这个指标来衡量系统CPU的占用或者一款App对系统CPU的占用。</p>
<p><strong>概念</strong></p>
<hr />
<p>　　首先需要知道，在Linux系统下，CPU利用率分为用户态、系统态、空闲态，分别表示CPU处于用户态执行的时间，系统内核执行的时间，和空闲系统进程执行的时间。（如下图）</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/626346/201601/626346-20160120154038750-1566606034.png" /></p>
<p>　　CPU使用率计算公式如下：</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/626346/201601/626346-20160120155951390-988166167.png" />　　</p>
<p>　　那么我们来看看怎么这个<strong>时间</strong>究竟是什么？</p>
<p>　　</p>
<p>　　先介绍几个和Linux时间有关的名词：HZ、tick与jiffies。</p>
<p>　　<strong>HZ</strong>：Linux 核心每隔固定周期会发出timer interrupt (IRQ 0)，HZ是用来定义每一秒有几次timer interrupts。例如HZ为1000，就代表每秒有1000次timer interrupts。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/626346/201602/626346-20160203133002382-1494918041.png" /></p>
<p>这是我在Nexus 5 上截取的手机试试的一个cpu频率</p>
<p>　　<strong>Tick</strong> ：Tick是HZ的倒数，Tick = 1/HZ 。即timer interrupt每发生一次中断的时间。如HZ为250时，tick为4毫秒(millisecond)。</p>
<p>　　<strong>Jiffies</strong> ：Jiffies 为Linux核心变数，是一个unsigned long类型的变量，它被用来记录系统自开机以来，已经过了多少tick。每发生一次timer interrupt，Jiffies变数会被加1.</p>
<p>　　所以我们可以得出，CPU利用率计算公式也就是：</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/626346/201601/626346-20160121174956062-1525878955.png" /></p>
<p>　　那么如果查看Jiffies 值呢？</p>
<p><strong>Jiffies</strong></p>
<hr />
<p>　　查看Jiffies的方法，我需要在shell中输入cat /proc/stat命令</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/626346/201601/626346-20160121175038359-541551490.jpg" />　</p>
<p>　　上图中的前5行是我们关注的重点，首先纵向CPU0、CPU1、CPU2、CPU3说明当前手机是四核的CPU，代表了每个核的Jiffies ，第一行CPU 就代表总的的Jiffes。</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/626346/201601/626346-20160121175046797-221043111.png" /></p>
<p>　　而每一列的数值分别代表了（如上图所示），详细的含义如下：</p>
<p>　　　　user ：从系统启动开始累计到当前时刻，用户态的jiffies ，不包含 nice值为负进程；</p>
<p>　　　　nice ：从系统启动开始累计到当前时刻，nice值为负的进程所占用的jiffies；</p>
<p>　　　　system ：从系统启动开始累计到当前时刻，系统态的jiffies；</p>
<p>　　　　idle ：从系统启动开始累计到当前时刻，除硬盘IO等待时间以外其它等待的jiffies；</p>
<p>　　　　iowait ： 从系统启动开始累计到当前时刻，硬盘IO等待的jiffies；</p>
<p>　　　　irq ： 从系统启动开始累计到当前时刻，硬中断的jiffies；</p>
<p>　　　　softirq ：从系统启动开始累计到当前时刻，软中断的jiffies。</p>
<p>　　总的Jiffies就是上面所有项加起来的总和。因此我们计算一段时间的CPU占用率的时候就可以使用：</p>
<p>　　　　total=user+system+nice+idle+iowait+irq+softirq</p>
<p>　　　　cpu usage=[(user_end +sys_end+nice_end) - (user_begin + sys_begin+nice_begin)]/(total_end - total_begin)*100</p>
<p><strong>进程的Jiffes</strong></p>
<hr />
<p>　　根据上面的介绍我们已经知道了Jiffies的作用，所以当有的时候我们需要查看一个App的CPU性能时，就需要对该App应用的进程的Jiffies进行分析。获取应用Jiffies的方法这里还是介绍两种，一种是使用GT直接采集，第二种是命令行查看的方式。</p>
<p>　　<strong>一、GT采集</strong></p>
<p>　　　　如同前一节的方法一样，选择好要采集的应用（以qq为例），勾选Jiffes，开始采集即可。（如下图）</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/626346/201601/626346-20160124184258468-2078933027.png" /></p>
<p>　　一般我们关注的是应用的前台进程，从进程名我们可以区分出来：</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/626346/201601/626346-20160124184435843-118694412.png" /></p>
<p>　　使用GT，可以直接查看数据，也可以将源数据保存下来，自己做分析。</p>
<p>　<strong>　二、shell获取</strong></p>
<p>　　shell的命令为：&nbsp;cat /proc/<em>进程id</em>/stat</p>
<p>　　首先我们需要使用 ps 命令查看qq这个应用的前台进程的进程id是多少，然后再去查看它的信息，如下图：</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/626346/201601/626346-20160124185725343-165311892.jpg" /></p>
<p>　　我们可以看到，得到了很多数据，这些数据的含义分别是：</p>
<p>　　　　pid=20324&nbsp; 进程号（平时所说的pid）<br />　　　　comm=(encent.mobileqq) 应用程序或命令的名字<br />　　　　task_state=S 任务的状态，R:runnign, S:sleeping (TASK_INTERRUPTIBLE), D:disk sleep (TASK_UNINTERRUPTIBLE), T: stopped, T:tracing stop,Z:zombie, X:dead<br />　　　　ppid=174&nbsp;父进程ID<br />　　　　pgid=174&nbsp;线程组号<br />　　　　sid=0&nbsp;c该任务所在的会话组ID<br />　　　　tty_nr=0&nbsp;(pts/3) 该任务的tty终端的设备号，INT（34817/256）=主设备号，（34817-主设备号）=次设备号<br />　　　　tty_pgrp=-1 终端的进程组号，当前运行在该任务所在终端的前台任务(包括shell 应用程序)的PID。<br />　　　　task-&gt;flags=1077936448&nbsp;进程标志位，查看该任务的特性<br />　　　　min_flt=166543&nbsp;该任务不需要从硬盘拷数据而发生的缺页（次缺页）的次数<br />　　　　cmin_flt=1212&nbsp; 累计的该任务的所有的waited-for进程曾经发生的次缺页的次数目<br />　　　　maj_flt=454 该任务需要从硬盘拷数据而发生的缺页（主缺页）的次数<br />　　　　cmaj_flt=0 累计的该任务的所有的waited-for进程曾经发生的主缺页的次数目<br />　　　<strong>　utime=8582&nbsp;该任务在用户态运行的时间，单位为jiffies</strong><br /><strong>　　　 &nbsp;stime=3419 该任务在核心态运行的时间，单位为jiffies</strong><br />　　　　cutime=0 累计的该任务的所有的waited-for进程曾经在用户态运行的时间，单位为jiffies<br />　　　　cstime=7 累计的该任务的所有的waited-for进程曾经在核心态运行的时间，单位为jiffies<br />　　　　priority=20 任务的动态优先级<br />　　　　nice=0 任务的静态优先级</p>
<p><em>　　　　</em>.......(内容太多，如需了解自己去查阅资料吧，这里只介绍和本节有关的)</p>
<p>　　根据上面每个字段的含义，我们就可以知道，当前进程的我们要的Jiffies值就是utime和stime的和。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy1yv2q.html">天河微信小程序入门《三》：打通任督二脉，前后台互通</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9337vr9.html">&amp;amp&semi;&amp;amp&semi; 和 &vert;&vert;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvwkl19.html">Java 操作符</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r27deq.html">eval 函数的应用 （去除包装在列表外面的引号）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9prejzq.html">Erwin 生成 mysql 带注释&lpar;comment &rpar;的脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x7yvz9.html">移动设备3G网站制作的detail</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvod3yq.html">对REST的一些理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j064xeq.html">纯手工打造dropdownlist控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm0o769.html">关于OC头文件互相引用的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnvx1j8.html">arcgis engine - 命令和工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydz5xdq.html">Java的一点内容（2）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojdxgxq.html">cc2530 寄存器PICTL理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyj3ze9.html">Unity使用Mono&period;Xml代替System&period;Xml 测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pgyjn8.html">&dollar;&period;extend&lpar;&rpar;方法和&lpar;function&lpar;&dollar;&rpar;&lbrace;&period;&period;&period;&rcub;&rpar;&lpar;jQuery&rpar;详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1kmggq.html">enumerate列表继续前文的计数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zrvye9.html">Git 最佳实践：分支管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/902mezoq.html">Tomcat服务器集群与负载均衡实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k0o4wq.html">jq 获取name值一样的数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjydw28.html">UML 类图详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o42mnxq.html">ProtocolBuffer 使用及 一些坑</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9pzl578.html">POJ3057 Evacuation（二分图最大匹配）</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o77leq.html">首发 手把手教你制作 Windows8 应用程序内部的 hubtile （动态瓷砖控件） MetroStyle（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlyzje9.html">【POJ】1269 Intersecting Lines（计算几何基础）</a>
			</li>
						<li><a href="https://www.batexi.com/a/390ow139.html">&lbrack;BZOJ 4436&rsqb;&lbrack;Cerc2015&rsqb;Kernel Knights</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pz11y8.html">X&period;509证书&lowbar;生成X&period;509协议的证书</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q27djw8.html">HTML&amp;lt&semi;marquee&amp;gt&semi;标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw7djk8.html">NSCharacterSet 简单用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z51v38.html">Java 反射机制学习资料</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8z517d8.html">三星S4接电话黑屏无法挂断通话</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8oxjdl8.html">php读取3389脚本</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
